import {
    pgTable,
    bigint,
    timestamp,
    text,
    doublePrecision,
    boolean,
    uuid,
} from "drizzle-orm/pg-core"

import { tenants } from "./tenants"
import { authUsers } from "./auth_users"

export const servicecategories = pgTable("servicecategories", {
    id: bigint("id", { mode: "number" })
        .primaryKey()
        .generatedByDefaultAsIdentity(),

    created_at: timestamp("created_at", { withTimezone: true })
        .notNull()
        .defaultNow(),

    tenant: bigint("tenant", { mode: "number" })
        .notNull()
        .references(() => tenants.id),

    name: text("name").notNull(),
    description: text("description"),

    discount: doublePrecision("discount").default(0),

    archived: boolean("archived").notNull().default(false),

    updated_at: timestamp("updated_at", { withTimezone: true }),
    updated_by: uuid("updated_by").references(() => authUsers.id),
})

export type ServiceCategory = typeof servicecategories.$inferSelect
export type NewServiceCategory = typeof servicecategories.$inferInsert
